



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>go语言学习-函数</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">go语言学习-函数</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-16 21:05:06 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<h2>函数声明</h2>
<p>函数声明包括函数名，形参列表，返回值列表(可选),函数体组成</p>
<pre class="prettyprint linenums"><code>func test(parameters) (returns) {<br />
    // ...<br />
}<br />
</code></pre>
<p>其中 parameters 就是函数的形参列表，描述了函数的参数名和参数类型，可以没有参数但是这个括号不可以省略; returns就是返回值列表，描述了函数返回值的变量名(可选)和类型, 如果函数返回一个没有名字的参数或者没有返回值，就可以不要括号</p>
<p>这里的参数和返回值的类型都不能省略,不过可以简写(如果有的话)</p>
<p>例如:</p>
<pre class="prettyprint linenums"><code>func add(x int, y int) int {<br />
    return x + y;<br />
}

// 可以简写成<br />
func add(x, y int) int {<br />
    return x + y;<br />
}<br />
</code></pre>
<p>这里需要注意的是函数调用都必须按照声明顺序为所有的参数提供实参．并且Go语言的函数没有默认值，也不能通过参数名指定形参，因此形参和返回值的变量名对于函数调用者是没有用处的，只是在函数内部使用</p>
<h2>参数的传递方式</h2>
<p>如果实参是引用类型，如指针，slice,map,function,channel等类型，在函数内部进行修改，就会影响到传入的实参；</p>
<p>其他类型的实参是传递的是值的拷贝，对其修改不会影响函数外部。</p>
<h2>变长参数</h2>
<pre class="prettyprint linenums"><code>语法:

func test(x int, ns ...int) {<br />
    //...<br />
}<br />
</code></pre>
<p>就是在参数类型前面加上三个点 “…”,这里需要注意的地方是这个变参本质上是一个slice,可在函数内部直接访问，并且一个函数只能有一个变长参数，并且只能在最后的位置</p>
<p>例如:</p>
<pre class="prettyprint linenums"><code>func add(x int, nums ...int) int {<br />
    for i := range nums {<br />
        x += nums[i]<br />
    }<br />
    return x<br />
}<br />
</code></pre>
<p>上面就是实现n个数的加法</p>
<p>同时在调用变参函数是，也可以将slice作为实参，不过需要展开,就是在slice后面加 “…”</p>
<p>调用方式:</p>
<pre class="prettyprint linenums"><code>add(10, 20, 30)  // 60

// 也可以使用slice<br />
s := []int{10, 20, 40}<br />
add(10, ...s)  // 80<br />
</code></pre>
<h2>多返回值</h2>
<p>Go语言的函数支持多个返回值</p>
<pre class="prettyprint linenums"><code>func test() (int, int) {<br />
    return 1, 2<br />
}<br />
</code></pre>
<p>此时就返回两个值，就需要有两个变量来接收，也可以使用 _ 接收来忽略某个参数</p>
<p>同时我们还可以为返回值起个名字</p>
<pre class="prettyprint linenums"><code>func test() (x int, y, int) {<br />
    x = 10<br />
    y = 10<br />
    return<br />
}<br />
</code></pre>
<p>此时就可以使用return 隐式的返回参数了，会自动返回对应名字的参数，注意这里的返回值的名字不会影响函数外部．</p>
<h2>匿名函数</h2>
<p>go也支持匿名函数，可以直接赋值给变量，或者当做结构体的字段等</p>
<pre class="prettyprint linenums"><code>var add = func(x, y int) {<br />
    return x + y;<br />
}

// 然后就可以使用变量名调用<br />
add(10, 20)  // 30<br />
</code></pre>
<h2>函数的特点总结</h2>
<ul><li>函数声明包括函数名，形参列表，返回值列表(可选),函数体组成</li>
<li>不支持参数默认值</li>
<li>如果实参是引用类型，如指针，slice,map,function,channel等类型，进行修改，就回影响实参；</li>
<li>其他类型的实参是传递的是值的拷贝，对其修改不会影响函数外部</li>
<li>支持变长参数</li>
<li>支持多返回值</li></ul>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/m960xy94.html">Anders Hejlsberg 技术理想架构开发传奇</a>
		</li>
						<li><a href="https://www.batexi.com/a/m8zpy739.html">shell学习三十四天----printf详解</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k1mgm79.html">MyBatis的foreach语句详解 list  array  map</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxn5kgz8.html">键盘样式风格有关设置-iOS开发</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7m2771q.html">自动化中的PageObject思想</a>
		</li>
						<li><a href="https://www.batexi.com/a/90vk03o8.html">ADB 远程无线调试</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvvpzvjq.html">&lbrack;Redux&rsqb; Filtering Redux State with React Router Params</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7m5xpkq.html">兄弟连王牌PHP课程送三重豪礼啦！</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxnvxpj8.html">QueryFilter与SpatialFilter - 浅谈</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2wpe4oq.html">转：MVC分页</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7zm2xk9.html">C&plus;&plus;内存管理学习笔记（5）</a>
		</li>
						<li><a href="https://www.batexi.com/a/96p3r338.html">activity 嵌套一级fragment&comma;一级fragment嵌套二级fragment，在一级fragment中刷新二级fragment中的UI</a>
		</li>
						<li><a href="https://www.batexi.com/a/9ge6zl48.html">使用caffe训练mnist数据集 - caffe教程实战（一）</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1k3jp59.html">C&num;二维码与条形码的生成</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwvk7jl8.html">测试使用 Open Live Writer写博客</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jmmlzg9.html">hbase 学习（十五）缓存机制以及可以利用SSD作为存储的BucketCache</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jmn33w9.html">&lbrack;原&rsqb;&lbrack;JSBSim&rsqb;基于qt代码实现：TCP&vert;UDP与飞行模拟软件JSBSim的通信，现实模型飞行！</a>
		</li>
						<li><a href="https://www.batexi.com/a/9632e4v9.html">Facebook广告目标摘要</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnn7o5jq.html">第 17 章 使用API</a>
		</li>
						<li><a href="https://www.batexi.com/a/93jyyzz8.html">Sqoop 1&period;99&period;6 安装和使用</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qxdr41z9.html">Properties文件工具类的使用--获取所有的键值、删除键、更新键等操作</a>
			</li>
						<li><a href="https://www.batexi.com/a/qnvk0428.html">ROS学习笔记（二）  &num; ROS  NodeHandles</a>
			</li>
						<li><a href="https://www.batexi.com/a/9j1rryg9.html">Linux的capability深入分析（2）【转】</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pwy4ky8.html">如何把JS对象转成数组</a>
			</li>
						<li><a href="https://www.batexi.com/a/9j1rox09.html">常用的Unicode值范围</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxdr3309.html">5种PHP创建数组的方式</a>
			</li>
						<li><a href="https://www.batexi.com/a/9r53xg4q.html">SQL中的 if 结构和循环（while）结构</a>
			</li>
						<li><a href="https://www.batexi.com/a/8zy2wy19.html">石头剪刀布（智能判断你是否赢了）（if判断和for）</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gj0wr49.html">Office系列版本安装包下载</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwve2mz8.html">python之比较is与&equals;&equals;&lpar;转载）</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
